/*
 * FlightCanvas.java
 *
 * Created on August 20, 2006, 2:44 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package flightgame;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;
/**
 *
 * @author dcsab
 */
public class FlightCanvas extends GameCanvas implements CommandListener, Runnable {

  Sprite mFlight, mBalloon1, mBalloon2, mExplosive;
  private static int LEFT = 1;
  private static int RIGHT = 2;

  /**Construct the displayable*/
  public FlightCanvas() {
    super(true);
    jbInit();
    createFlight();


    Thread t = new Thread(this);
    t.start();
  }

  private void createFlight(){
   // Create the sprite.
   Image flightImage = null;
   try{
    flightImage = Image.createImage("/flightgame/mustang.png");
   }catch(IOException e) {}
   mFlight = new Sprite(flightImage, 36, 18);

   mFlight.setPosition(getWidth()/2,getHeight()/2);
   mFlight.defineReferencePixel(18, 9);
 }

   private void setDirection(int direc){
  if (direc == LEFT) {
    mFlight.setTransform(Sprite.TRANS_MIRROR);
  } else if (direc == RIGHT) {
    mFlight.setTransform(Sprite.TRANS_NONE);
  }

  }

  /** Implementing RUN method - (GAME LOOP) **/
 public void run() {
   Graphics g = getGraphics();
   g.setColor(0,255,255);

   boolean mFlag = true;

   while (mFlag) {

    int keyStates = getKeyStates();
     if ( (keyStates & LEFT_PRESSED) != 0) {
       setDirection(LEFT);
       mFlight.move( -3, 0);

     }
     else if ( (keyStates & RIGHT_PRESSED) != 0) {
       setDirection(RIGHT);
       mFlight.move(3, 0);

     }

     g.fillRect(0,0,getWidth(),getHeight());//Clear flight in previous position
     mFlight.paint(g);  //draw filght in new position

     flushGraphics();

     try { Thread.sleep(80); }
     catch (InterruptedException ie) {}

  }
  }

  /**Component initialization*/
  private void jbInit() {
    // set up this Displayable to listen to command events
    setCommandListener(this);
    // add the Exit command
    addCommand(new Command("Exit", Command.EXIT, 1));
  }

  /**Handle command events*/
  public void commandAction(Command command, Displayable displayable) {
    /** @todo Add command handling code */
    if (command.getCommandType() == Command.EXIT) {
// stop the MIDlet
      FlightMidlet.quitApp();
    }
  }

}
